;------------------------------------------------------------------------------+
;Well, this plays a wav with 4 bit quality using pulse code modulation(PCM)    |
;The wav is originally 8 bit, 11 kHz ... and MONO                              |
; (C)1996 by Andreas Ess                                                       |
;									       |
; * Try to improve the mem need!                                               |
; * There's an annoying 'upperwave' (or whatever this is called in english...) |
;   Try to remove it.                                                          |
;------------------------------------------------------------------------------+


#include "asm86.h"
#include "ti86asm.inc"

.org _asm_exec_ram
    nop
    jp Start      
    .dw 0
    .dw Title

Title:
.db "Change this comment!",0

Start:

 ld hl, Sound
 call Play4Bit
 ret


Play4Bit:
 di
 ld  e, (hl) ;get length
 inc  hl
 ld  d, (hl)
PlayLoop:
 ld  c, 6
 inc  hl
 ld  a, 15
 ld  b, (hl)  ;B is length of 1 bits, C of 0 bits
 sub  b
 ld  c, a
 dec  de
 ld  a, d
 or   e
 jr z,   DonePlay
 ld  a, 0FCh
 out  (7), a
BLoop:
 nop
 nop
 djnz BLoop
 ld  a, 0C0h
 out  (7), a
CLoop:
 nop
 dec  c
 jr nz,  CLoop
 jr  PlayLoop
DonePlay:
 ld  a, 0C0h
 out  (7), a
 ei
 ret

;** The wave file (toss your file here!):
;** 4 Bit Wave Player Data (C) 1996 by Andreas Ess
Sound:
 .dw 1
 .db 0

.end
