;Plays a 1-Bit, 11kHz, Mono WAV-File over a connected earphone...
; (C) 1996 by Andreas Ess
;If you use the code, please give me an appropriate credit.
;Send a postcard saying thank you to:
; Andreas Ess
; Tufers 156
; A-6811 Goefis
; Austria/Europe
;-----------------------------------------------------------------------------
;ported to the ti-86 by Andrew Waser without permission (I didn't do much,
;just made it compatible..)
;-----------------------------------------------------------------------------


#include "asm86.h"
#include "ti86asm.inc"

.org _asm_exec_ram
    nop
    jp Start      
    .dw 0
    .dw Title

Title:
.db "Change this comment!",0

Start:


 ld hl, Sound
 call PlayWAV

 ret

PlayWAV:
 di                    ;greylib by robert taylor can't be used :(
 ld   a, 0C0h         
 out   (7), a
 ld   e, (hl)
 inc   hl
 ld   d, (hl)
 inc   hl
 ld   b, 128           ;b is used as a mask
SoundLoop:
 ld   c, 19

DLoop:
 dec   c
 jr nz,   DLoop
 nop
 nop
 rrc   b
 jr nc,   Play
 inc   hl               ;next byte
 dec   de
 ld   a, d
 or    e
 jr z,    DonePlay
 xor   a                ;exit key pressed?
 out   (1), a
 in    a, (1)
 bit   6, a
 jr z,    DonePlay
Play:
 ld   a, (hl)          ;get bit
 and   b
 jr z,    Play1
 ld   a, 0FCh
 out   (7), a
 jr   SoundLoop
Play1:
 ld   a, 0C0h
 out   (7), a
 jr   SoundLoop
DonePlay:
 ld  a, 0C0h
 out  (7), a
 ei
 ret

;-----------------------------------------------------------------------------
;The WAV-File:
;-----------------------------------------------------------------------------
Sound:
 .dw 1            ;replace this with your sound!
 .db 00           ;(use wav2db)
.end
